exec("./Support_ExtUINameTable.cs");
exec("./Support_ColorPicker.cs");
if(!$loadedAutoDelayGui)
{
	exec("./eventprefs.gui");
	exec("./AutoDelay.gui");
	exec("./EventSaver.gui");
	exec("./EventYouSure.gui");
	$loadedAutoDelayGui = true;
}

$EventSystem::Version = 1.74;

$indentSize = 30;
$eventShowTrans = true;
$eventSwatchcolor[0] = "0 0 0 51";
$eventSwatchcolor[1] = "175 0 0 51";
$eventSwatchcolor[2] = "0 100 0 51";
$eventSwatchcolor[3] = "0 0 100 51";

function checkprivilege()
{
	%sjw = privilegeCheck.getValue();
	if(!%sjw && isObject(magaSwatch))
		magaSwatch.delete();
	else if(%sjw && !isObject(magaSwatch))
	{
		new GuiBitmapCtrl(magaSwatch) 
		{
         		profile = "BlockTextEditProfile";
         		horizSizing = "width";
         		vertSizing = "height";
            		position = "200 200";
            		extent = "200 200";
         		minExtent = "8 2";
         		enabled = "1";
         		visible = "1";
         		clipToParent = "1";
         		wrap = "0";
         		lockAspectRatio = "1";
         		alignLeft = "0";
         		alignTop = "0";
         		overflowImage = "1";
         		keepCached = "0";
         		mColor = "255 255 255 170";
         		mMultiply = "0";
			bitmap = "Add-ons/system_eventing/ui/dank";
		};
		WrenchEvents_Window.add(magaSwatch);
		//WrenchEvents_Window.pushToBack(magaswatch);
	}
}

function reloadEventSavesList()
{
	eventSavesList.clear();
	%inc = 1;
	while((%file = findNextFile("config/client/eventsaves/*")) !$= "")
		eventSavesList.addRow(%inc++,getSubStr(%file,25,strlen(%file)-25));
}

function overwriteEvents()
{
	clearWrenchEventsBox();
	WrenchEventsDlg.newEvent();
	appendEvents();
}

function appendEvents()
{
	%eventFileName = eventSavesList.getValue();
	if(strlen(%eventFileName) < 1)
		return;
	%eventFileName = "config/client/eventsaves/" @ %eventfileName;
	%file = new FileObject();
	%file.openForRead(%eventfileName);
	%lastCreatedSwatch = 0;
	while(!%file.iseof())
	{
		%line = %file.readLine();
		%fc = getFieldCount(%line);
		%type = getField(%line,0);
		if(%type $= "E")
		{
			%bottomSwatch = WrenchEvents_Box.order[WrenchEvents_Box.highestOrder-1];
			%bottomSwatch.enabledBox.setValue(getField(%line,1));
			%bottomSwatch.delayBox.setValue(getField(%line,2));
			%bottomSwatch.inputButton.noFocus = true;
			for(%a=0;%a<$InputEvent_CountfxDTSBrick;%a++)
				if($InputEvent_NamefxDTSBrick_[%a] $= getField(%line,5))
					%bottomSwatch.inputButton.setSelected(%a);

			%targets = $InputEvent_TargetListfxDTSBrick_[%bottomSwatch.inputButton.getSelected()];
			%bottomSwatch.targetButton.noFocus = true;
			if(getField(%line,6) $= "Named Brick")
			{
				if(ServerConnection.NTNameCount > 0)
					%bottomSwatch.targetbutton.setselected(999);
				else
				{
					%bottomSwatch.targetbutton.add("Named Brick",999);
					%bottomSwatch.targetbutton.setSelected(999);
					%bottomSwatch.targetbutton.setActive(false);
				}
			}
			else
			{
				for(%a = 0; %a<getFieldCount(%targets); %a++)
				{
					%target = getField(%targets,%a);
					if(getWord(%target,0) $= getField(%line,6))
						%bottomSwatch.targetButton.setSelected(%a);
				}
			}

			%tar = %bottomSwatch.targetButton.getSelected();
			if(%tar == 999)
				%tar = 0;
			%className = getWord(getField(%targets,%tar),1);
			for(%a=0;%a<$OutputEvent_Count[%className];%a++)
				if($OutputEvent_Name[%className,%a] $= getField(%line,7))
					%bottomSwatch.outputButton.setSelected(%a);

			%bottomSwatch.colorID = getField(%line,3);
			%bottomSwatch.indent = getField(%line,4);

			%params = %fc - 8;
			for(%a=0;%a<%params;%a++)
			{
				%element = %bottomSwatch.param[%a];
				%param = getField(%line,8+%a);
				if(%element.paramType $= "intlist" || %element.paramType $= "string" || %element.paramType $= "int" || %element.paramType $= "float" || %element.paramType $= "bool")
					%element.setValue(%param);
				else if(%element.paramType $= "vector")
				{
					%element.getObject(0).setValue(getWord(%param,0));
					%element.getObject(1).setValue(getWord(%param,1));
					%element.getObject(2).setValue(getWord(%param,2));
				}
				else if(%element.paramType $= "list" || %element.paramType $= "datablock")
					%element.setSelected(%element.entryID[%param]);
				else if(%element.paramType $= "paintColor")
				{
					%element.picked = %param;
					%element.color = getColorI(getColorIDTable(%param));
				}
			}

			%lastCreatedSwatch = %bottomSwatch;
		}
		else if(%type $= "N")
		{
			if(isObject(%lastCreatedSwatch))
			{
				%nameID = -1;
				for(%a=0;%a<ServerConnection.NTNameCount;%a++)
				{
					if(ServerConnection.NTName[%a] $= ("_" @ getField(%line,1)))
					{
						%nameID = %a;
						break;
					}
				}
				if(isObject(%lastCreatedSwatch.namedBrickButton))
					%lastCreatedSwatch.namedBrickButton.setSelected(%nameID);
			}
		}
	}
	%file.close();
	%file.delete();
	reordereventslist();
}

function saveEvents()
{
	%events = WrenchEvents_Box.highestOrder;
	if(%events < 2)
		return;
	%saveName = eventSaveName.getValue();
	if(strlen(%saveName) < 1)
		return;
	%file = new FileObject();
	%file.openForWrite("config/client/eventsaves/" @ %saveName @ ".bes");
	for(%a=0;%a<%events;%a++)
	{
		%swatch = WrenchEvents_Box.order[%a];
		if(!isObject(%swatch.outputButton))
			continue;
		%line = "E";
		%line = %line TAB %swatch.enabledBox.getValue();
		%line = %line TAB %swatch.delayBox.getValue();
		%line = %line TAB %swatch.colorID;
		if(%swatch.indent < 1)
			%swatch.indent = 0;
		%line = %line TAB %swatch.indent;
		%line = %line TAB %swatch.inputButton.getValue();
		%line = %line TAB %swatch.targetButton.getValue();
		%line = %line TAB %swatch.outputButton.getValue();
		for(%b=0;%b<%swatch.params;%b++)
			%line = %line TAB getParam(%swatch.param[%b],true);
		%file.writeLine(%line);
		if(%swatch.targetButton.getValue() $= "Named Brick")
			%file.writeLine("N" TAB %swatch.namedBrickButton.getValue());
	}
	%file.close();
	%file.delete();
	reloadEventSavesList();
}

function eventSureYes()
{
	canvas.popdialog(eventyousure);
	%eventFileName = $eventSaveToDelete;
	$eventSaveToDelete = "";
	if(strlen(%eventFileName) < 1)
		return;
	%eventFileName = "config/client/eventsaves/" @ %eventfileName;
	fileDelete(%eventfileName);
	reloadeventsaveslist();
}

function deleteEventSave()
{
	$eventSaveToDelete = eventSavesList.getValue();
	canvas.pushdialog(eventYouSure);
	reloadEventSavesList();
}

function applyAutoDelay()
{
	canvas.popDialog(AutoDelay);
	%start = autoDelay_startRow.getValue();
	%end = autoDelay_endRow.getValue();
	%startms = autoDelay_startms.getValue();
	%stepms = autoDelay_stepms.getValue();
	%inc = 0;
	for(%a=%start;%a<=%end;%a++)
	{
		%swa = WrenchEvents_Box.order[%a];
		if(isObject(%swa))
		{
			%swa.delayBox.setValue(%startms + (%inc*%stepms));
			%inc++;
		}
	}
}

function changeEventWindow()
{
	if($eventGuiModded)
		return;
	$eventGuiModded = true;

	%thingsToDelete = 0;
	for(%a=0;%a<WrenchEvents_Window.getCount();%a++)
	{
		%obj = WrenchEvents_Window.getObject(%a);
		if(%obj.getClassName() $= "guiSwatchCtrl" || %obj.getClassName() $= "GuiTextCtrl")
		{
			%thingToDelete[%thingsToDelete] = %obj;
			%thingsToDelete++;
		}
	}
	for(%a=0;%a<%thingsToDelete;%a++)
		%thingToDelete[%a].delete();

        new GuiPopUpMenuCtrl(newEventDropDown)
	{
                 profile = "GuiPopUpMenuProfile";
                 horizSizing = "right";
                 vertSizing = "bottom";
                 position = "100 30";
                 extent = "100 16";
                 minExtent = "8 2";
                 enabled = "1";
                 visible = "1";
                 clipToParent = "1";
                 maxLength = "255";
                 maxPopupHeight = "200";
		 command="doDropDownOption();";
        };
	WrenchEvents_Window.add(newEventDropDown);
	addDropDownEventOptions(newEventDropDown);

	new GuiSwatchCtrl(eventInsertSwatch)
	{
		keepIt = true;
		color = "255 0 0 150";
		position = "0 35";
		extent = getword(wrenchEvents_Scroll.extent,0) @ " 7";
		enabled = true;
		visible = false;
		clipToParent = true;
                profile = "GuiPopUpMenuProfile";
                horizSizing = "right";
                vertSizing = "bottom";
	};
	WrenchEvents_Box.add(eventInsertSwatch);
}

function clearWrenchEventsBox()
{
	if($eventDebug)
		return;
	//WrenchEvents_Box.deleteAll();
	%thingsToDelete = 0;
	for(%a=0;%a<WrenchEvents_Box.getCount();%a++)
	{
		%thi = WrenchEvents_Box.getObject(%a);
		if(!%thi.keepIt)
		{
			%thingToDelete[%thingsToDelete] = %thi;
			%thingsToDelete++;
		}
	}
	for(%a=0;%a<%thingsToDelete;%a++)
		%thingToDelete[%a].delete();
	WrenchEvents_Box.extent = getword(wrenchEvents_Scroll.extent,0) @ " 1";
	WrenchEvents_Box.highestOrder=0;
}

function addOutputEventsToButton(%button,%class)
{
	%button.clear();
	%button.add(" - ",-1);
	%num = $OutputEvent_Count[%class];
	for(%a=0;%a<%num;%a++)
		%button.add($OutputEvent_Name[%class,%a],%a);
	%button.sort();
}

function addTargetsToButton(%button,%event)
{
	%button.clear();
	%button.add(" - ",-1);
	%targets = $InputEvent_TargetListfxDTSBrick_[%event];
	%shouldAddNamedBrick = false;
	for(%a = 0; %a<getFieldCount(%targets); %a++)
	{
		%target = getField(%targets,%a);
		%button.add(getWord(%target,0),%a);
		if(getWord(%target,1) $= "fxDTSBrick")
		{
			if(ServerConnection.NTNameCount > 0)
			{
				%button.brickOption = %a;
				%shouldAddNamedBrick = true;
			}
		}
	}
	if(%shouldAddNamedBrick && serverconnection.allownamedtargets)
		%button.add("Named Brick",999);
	//%button.sort();
}

function addInputEventsToButton(%button)
{
	%button.clear();
	%button.add(" - ",-1);
	for(%a=0;%a<$InputEvent_CountfxDTSBrick;%a++)
		%button.add($InputEvent_NamefxDTSBrick_[%a],%a);
	%button.sort();
}

function hasNewEvent()
{
	for(%a=0;%a<WrenchEvents_Box.highestOrder;%a++)
	{
		%swatch = WrenchEvents_Box.order[%a];
		if(!isObject(%swatch.targetButton))
			return true;
	}
	return false;
}

function reorderEventsList()
{
	%totalSize = 0;
	%newHighestOrder = 0;
	for(%a=0;%a<WrenchEvents_Box.highestOrder;%a++)
	{
		if(isObject(WrenchEvents_Box.order[%a]))
		{
			%newOrder[%newHighestOrder] = WrenchEvents_Box.order[%a];
			%newHighestOrder++;
		}
	}
	WrenchEvents_Box.highestOrder = %newHighestOrder;
	for(%a=0;%a<%newHighestOrder;%a++)
		WrenchEvents_Box.order[%a] = %newOrder[%a];
	%neededExtraWidth = 0;
	for(%a=0;%a<WrenchEvents_Box.highestOrder;%a++)
	{
		%obj = WrenchEvents_Box.order[%a];
		%obj.position = %obj.indent*$indentSize SPC %totalSize;
		%totalSize += getWord(%obj.extent,1)+6;
		%obj.enabledBox.text = %a;
		if(%obj.indent > %neededExtraWidth)
			%neededExtraWidth = %obj.indent;
	}
	%neededExtraWidth *= $indentSize;
	WrenchEvents_Box.extent = getword(wrenchEvents_Scroll.extent,0)+%neededExtraWidth SPC %totalSize;
	for(%a=0;%a<WrenchEvents_Box.highestOrder;%a++)
	{
		%col = $eventSwatchColor[WrenchEvents_Box.order[%a].colorID];
		if(WrenchEvents_Box.order[%a].selected)
			%col = getWord(%col,0) SPC getWord(%col,1) SPC getWord(%col,2) SPC "150";
		WrenchEvents_Box.order[%a].color = %col;
	}
	WrenchEvents_Box.setvisible(1);
}

function addBrickNamesToButton(%button)
{
	%button.clear();
	for(%a=0;%a<ServerConnection.NTNameCount;%a++)
		%button.add(getSubStr(ServerConnection.NTName[%a],1,strlen(ServerConnection.NTName[%a])-1),%a);
	%button.sort();
}

function populateButton(%button,%datablock)
{
	%button.dataType = %datablock;
	%button.clear();
	if(%datablock $= "Music")
	{
		%datablock = "AudioProfile";
		for(%a=0;%a<$ExtUINameTableCount[%datablock];%a++)
			if(strlen($ExtUINameTableID[%datablock,%a].uiName) > 0)
				%button.add($ExtUINameTableID[%datablock,%a].uiName,$ExtUINameTableID[%datablock,%a]);
	}
	else if(%datablock $= "Sound")
	{
		for(%a=0;%a<getDatablockGroupSize();%a++)
		{
			%db = getDatablock(%a);
			if(%db.getClassName() $= "AudioProfile")
			{
				if(strlen(%db.uiName) < 1)
				{
					%button.add(fileName(%db.fileName),%db);
					%button.entryID[fileName(%db.fileName)] = %db;
				}
			}
		}
	}
	else
	{
		for(%a=0;%a<$ExtUINameTableCount[%datablock];%a++)
		{
			if(strlen($ExtUINameTableID[%datablock,%a].uiName) > 0)
			{
				%button.add($ExtUINameTableID[%datablock,%a].uiName,$ExtUINameTableID[%datablock,%a]);
				%button.entryID[$ExtUINameTableID[%datablock,%a].uiName] = $ExtUINameTableID[%datablock,%a];
			}
		}
	}
	%button.sort();
	%button.addFront("None",-1);
	%button.entryID["None"] = -1;
}

function getParam(%param2,%name)
{
	%arg2 = "";
	if(!isObject(%param2))
		return "";
	if(%param2.paramType $= "intlist" || %param2.paramType $= "int" || %param2.paramType $= "bool" || %param2.paramType $= "float" || %param2.paramType $= "string")
		%arg2 = %param2.getValue();
	else if(%param2.paramType $= "vector")
		%arg2 = %param2.getObject(0).getValue() SPC %param2.getObject(1).getValue() SPC %param2.getObject(2).getValue();
	else if(%param2.paramType $= "datablock" || %param2.paramType $= "list")
	{
		if(%name)
			%arg2 = %param2.getValue();
		else
			%arg2 = %param2.getSelected();
	}
	else if(%param2.paramType $= "paintColor")
		%arg2 = %param2.picked;
	return %arg2;
}

function clientcmdeventsystemversion(%has,%version)
{
	$serverEventSystemVersion = %version;
	$serverHasEventSystem = true;
}

function getEventCursorPos()
{
	%pos = canvas.getCursorPos();
	return vectorSub(vectorSub(%pos,WrenchEvents_Window.position),wrenchEvents_Scroll.position);
}

function findCursorSwatch(%extend)
{
	%scrollAmount = -getWord(WrenchEvents_Box.position,1);
	%cursor = getEventCursorPos();
	if(getWord(%cursor,0) < 0 || getWord(%cursor,1) < 0)
		return -1;
	%cursor = getWord(%cursor,0) SPC getWord(%cursor,1)+%scrollAmount;
	for(%a=0;%a<WrenchEvents_Box.highestOrder;%a++)
	{
		%swatch = WrenchEvents_Box.order[%a];
		if(!%extend)
		{
			if(getWord(%swatch.position,0) < getWord(%cursor,0) && getWord(%swatch.position,1) < getWord(%cursor,1))
			{
				if(getWord(%swatch.position,0)+getWord(%swatch.extent,0) > getWord(%cursor,0) && getWord(%swatch.position,1)+getWord(%swatch.extent,1) > getWord(%cursor,1))
				{
					return %a;
				}
			}
		}
		else
		{
			if(getWord(%swatch.position,0) < getWord(%cursor,0) && getWord(%swatch.position,1) < getWord(%cursor,1))
			{
				if(getWord(%swatch.position,0)+getWord(%swatch.extent,0) > getWord(%cursor,0) && getWord(%swatch.position,1)+getWord(%swatch.extent,1)+7 > getWord(%cursor,1))
				{
					return %a;
				}
			}
		}
	}
	return -1;
}

function highlightcursorswatch()
{
	if($eventSelectingMode == 3 || $eventSelectingMode == 4)
	{
		for(%a=0;%a<WrenchEvents_Box.highestOrder;%a++)
		{
			%col = $eventSwatchColor[WrenchEvents_Box.order[%a].colorID];
			if(WrenchEvents_Box.order[%a].selected)
				%col = getWord(%col,0) SPC getWord(%col,1) SPC getWord(%col,2) SPC "150";
			WrenchEvents_Box.order[%a].color = %col;
		}
		%swa = findCursorSwatch(true);
		if(%swa != -1)
			eventInsertSwatch.visible = true;
		else
			eventInsertSwatch.visible = false;
		eventInsertSwatch.position = "0" SPC getWord(WrenchEvents_Box.order[%swa].position,1)+35;
		cancel($cursorSwatchHighlight);
		$cursorSwatchHighlight = schedule(50,0,highlightcursorswatch);
		return;
	}
	else
		eventInsertSwatch.visible = false;

	if($eventSelectingMode != 1)
	{
		for(%a=0;%a<WrenchEvents_Box.highestOrder;%a++)
		{
			%col = $eventSwatchColor[WrenchEvents_Box.order[%a].colorID];
			if(WrenchEvents_Box.order[%a].selected)
				%col = getWord(%col,0) SPC getWord(%col,1) SPC getWord(%col,2) SPC "150";
			WrenchEvents_Box.order[%a].color = %col;
		}
		return;
	}
	%swa = findCursorSwatch();
	for(%a=0;%a<WrenchEvents_Box.highestOrder;%a++)
	{
		%col = $eventSwatchColor[WrenchEvents_Box.order[%a].colorID];
		if(WrenchEvents_Box.order[%a].selected)
			%col = getWord(%col,0) SPC getWord(%col,1) SPC getWord(%col,2) SPC "150";
		WrenchEvents_Box.order[%a].color = %col;
	}
	WrenchEvents_Box.order[%swa].color = "255 255 0 100";
	cancel($cursorSwatchHighlight);
	$cursorSwatchHighlight = schedule(50,0,highlightcursorswatch);
}

function addDropDownEventOptions(%button)
{
    %button.clear();
    %button.add("-",-1);
    %button.add("Change Color",1);
    %button.add("Select",2);
    %button.add("Paste",3);
    %button.add("Auto-Delay",4);
    %button.add("Save/Load",5);
    %button.add("Insert Line",6);
    %button.add("Preferences",7);
}

function deselectEvents()
{
    $eventsSelected = 0;
    for(%a=0;%a<WrenchEvents_Box.highestOrder;%a++)
        WrenchEvents_Box.order[%a].selected = false;
}

function eventPrefs::onWake(%this)
{
    eventIndentSize.command = "$indentSize=eventIndentSize.getValue(); reordereventslist();";
    eventColor0.setValue($eventSwatchColor[0]);
    eventColor1.setValue($eventSwatchColor[1]);
    eventColor2.setValue($eventSwatchColor[2]);
    eventColor3.setValue($eventSwatchColor[3]);
    eventTransColors.setValue($eventShowTrans);
}

function applyeventprefs()
{
    $eventSwatchColor[0] = eventcolor0.getvalue();
    $eventSwatchColor[1] = eventcolor1.getvalue();
    $eventSwatchColor[2] = eventcolor2.getvalue();
    $eventSwatchColor[3] = eventcolor3.getvalue();
    $eventShowTrans = eventTransColors.getValue();
    canvas.popdialog(eventprefs);
    reordereventslist();
}

function doDropDownOption()
{
    %op = newEventDropDown.getSelected();
    if(%op == -1)
    {
        deselectEvents();
        $eventSelectingMode = 0;
    }
    if(%op == 1)
    {
        $eventSelectingMode = 2;
    }
    else if(%op == 2)
    {
        $eventSelectingMode = 1;
        highlightcursorswatch();
    }
    else if(%op == 3)
    {
        $eventSelectingMode = 3;
        $eventsSelected = 0;
        for(%a=0;%a<WrenchEvents_Box.highestOrder;%a++)
        {
            %q = WrenchEvents_Box.order[%a];
            if(%q.selected)
            {
                $eventSelected[$eventsSelected] = %q;
                $eventsSelected++;
            }
        }
        highlightcursorswatch();
    }
    else if(%op == 4)
    {
        canvas.pushdialog(autoDelay);
    }
    else if(%op == 5)
    {
        reloadEventSavesList();
        canvas.pushDialog(eventSaver);
    }
    else if(%op == 6)
    {
        $eventSelectingMode = 4;
        highlightcursorswatch();
    }
    else if(%op == 7)
    {
        canvas.pushdialog(eventprefs);
    }
}

function backButtonClicked(%swatch)
{
    if($eventSelectingMode == 1)
    {
        %swatch.selected = !%swatch.selected;
    }
    else if($eventSelectingMode == 2)
    {
        %swatch.colorID++;
        if(%swatch.colorID > 3)
            %swatch.colorID = 0;
        %swatch.mcolor = $eventSwatchColor[%swatch.colorID];
    }
    else if($eventSelectingMode == 3)
    {
        for(%a=$eventsSelected-1;%a>=0;%a--)
            %copiedSelections[%a] = eventCopy($eventSelected[%a],%swatch);
        deselectEvents();
    }
    else if($eventSelectingMode == 4)
    {
        eventCopy(%swatch,%swatch).inputbutton.ddsOpenMenu();
        //$eventSelectingMode = 0;
    }
    reorderEventsList();
}

function eventIndent(%swatch)
{
    if(%swatch.indent < 1)
        %swatch.indent = 0;
    %swatch.indent++;
    %swatch.position = %swatch.indent*$indentSize SPC getWord(%swatch.position,1);
    reorderEventsList();
}

function eventDedent(%swatch)
{
    %swatch.indent--;
    if(%swatch.indent < 1)
        %swatch.indent = 0;
    %swatch.position = %swatch.indent*$indentSize SPC getWord(%swatch.position,1);
}

function openSwatch(%swatch)
{
    for(%a=0;%a<%swatch.getcount();%a++)
        %swatch.getObject(%a).visible = true;
    %swatch.extent = getword(wrenchEvents_Scroll.extent,0) @ " 36";
    %swatch.theMinmize.position = "0 0";
    %swatch.minmized = false;
}

function collapseSwatch(%swatch,%prim)
{
    %swatch.minmized = true;
    %swatch.extent = getword(wrenchEvents_Scroll.extent,0) @ " 8";
    for(%a=0;%a<%swatch.getcount();%a++)
        %swatch.getObject(%a).visible = false;
    if(%prim)
    {
        %swatch.theMinmize.visible = 1;
        %swatch.theMinmize.position = "-2 -2";
    }
}

function eventCollapse(%swatch)
{
    %startID = -1;
    for(%a=0;%a<WrenchEvents_Box.highestOrder;%a++)
    {
        if(WrenchEvents_Box.order[%a] == %swatch)
        {
            %startID = %a;
            break;
        }
    }
    if(%startID == -1)
    {
        error("Startid == -1 eventcollapse");
        return;
    }

    %startID++;
    if(%swatch.minmized)
    {
        openSwatch(%swatch);
        while(WrenchEvents_Box.order[%startID].indent > %swatch.indent)
        {
            openSwatch(WrenchEvents_Box.order[%startID]);
            %startID++;
        }
    }
    else
    {
        collapseSwatch(%swatch,1);
        while(WrenchEvents_Box.order[%startID].indent > %swatch.indent)
        {
            collapseSwatch(WrenchEvents_Box.order[%startID],0);
            %startID++;
        }
    }
    reorderEventsList();
}

function eventUpper(%swatch)
{
    %startID = -1;
    for(%a=0;%a<WrenchEvents_Box.highestOrder;%a++)
    {
        if(WrenchEvents_Box.order[%a] == %swatch)
        {
            %startID = %a;
            break;
        }
    }
    if(%startID == -1)
    {
        error("Startid == -1 eventupper");
        return;
    }

    if(%startID < 1)
        return;

    %howFarBelow = 0;
    for(%id = %startID+1;%id<WrenchEvents_Box.highestOrder+1;%id++)
    {
        %howFarBelow++;
        if(WrenchEvents_Box.order[%id].indent <= %swatch.indent)
            break;
    }
    %howFarAbove = 0;
    for(%id = %startID-1;%id>-1;%id--)
    {
        %howFarAbove++;
        if(WrenchEvents_Box.order[%id].indent <= %swatch.indent)
            break;
        if(%id == 0)
        {
            %howFarAbove = -1;
            break;
        }
    }

    if(%howFarAbove == -1 || %howFarBelow == -1)
        return;

    for(%a=%startID;%a<%startID+%howFarBelow;%a++)
        WrenchEvents_Box.order[%a].newOrder = %a-%howFarAbove;
    for(%a=%startID-1;%a>=%startID-%howFarAbove;%a--)
        WrenchEvents_Box.order[%a].newOrder = %a+%howFarBelow;

    for(%a=0;%a<WrenchEvents_Box.highestOrder;%a++)
        %oldOrder[%a] = WrenchEvents_Box.order[%a];
    for(%a=0;%a<WrenchEvents_Box.highestOrder;%a++)
        WrenchEvents_Box.order[%oldOrder[%a].newOrder] = %oldOrder[%a];

    reorderEventsList();
}

function eventDowner(%swatch)
{
    %startID = -1;
    for(%a=0;%a<WrenchEvents_Box.highestOrder;%a++)
    {
        if(WrenchEvents_Box.order[%a] == %swatch)
        {
            %startID = %a;
            break;
        }
    }
    if(%startID == -1)
    {
        error("Startid == -1 eventdowner");
        return;
    }

    %howFarBelow = 0;
    for(%id = %startID+1;%id<WrenchEvents_Box.highestOrder+1;%id++)
    {
        %howFarBelow++;
        if(WrenchEvents_Box.order[%id].indent <= %swatch.indent)
            break;
    }

    if(%howFarBelow+%startID >= WrenchEvents_Box.highestOrder)
        return;

    %newStart = %howFarBelow+%startID;
    %howFarToMove = 0;
    for(%id = %newStart;%id<WrenchEvents_Box.highestOrder+1;%id++)
    {
        %howFarToMove++;
        if(WrenchEvents_Box.order[%id].indent <= %swatch.indent)
            break;
    }

    eventUpper(WrenchEvents_Box.order[%newStart]);
}

function eventCopy(%swatch,%underswatch)
{
    %startID = -1;
    for(%a=0;%a<WrenchEvents_Box.highestOrder;%a++)
    {
        if(WrenchEvents_Box.order[%a] == %swatch)
        {
            %startID = %a;
            break;
        }
    }
    if(%startID == -1)
    {
        error("Startid == -1 eventcopy");
        return;
    }

    %targetID = -1;
    for(%a=0;%a<WrenchEvents_Box.highestOrder;%a++)
    {
        if(WrenchEvents_Box.order[%a] == %underswatch)
        {
            %targetID = %a;
            break;
        }
    }
    if(%targetID == -1)
    {
        error("TargetID == -1 eventcopy");
        return;
    }

    wrenchEventsDlg.newEvent();
    %newSwatch = $newestEventLine;

    %newSwatch.indent = %swatch.indent;
    %newSwatch.colorID = %swatch.colorID;
    %newSwatch.enabledBox.setValue(%swatch.enabledBox.getValue());
    %newSwatch.delayBox.setValue(%swatch.delayBox.getValue());
    %newSwatch.inputButton.noFocus = true;
    %newSwatch.inputButton.setSelected(%swatch.inputButton.getSelected());
    %newSwatch.targetButton.noFocus = true;
    %newSwatch.targetButton.setSelected(%swatch.targetButton.getSelected());
    if(%swatch.targetButton.getSelected() == 999)
        %newSwatch.namedBrickButton.setSelected(%swatch.namedBrickButton.getSelected());
    %newSwatch.outputButton.setSelected(%swatch.outputButton.getSelected());
    for(%a=0;%a<%swatch.params;%a++)
    {
        %param = getParam(%swatch.param[%a]);
        if(strlen(%param) > 0)
        {
            %element = %newSwatch.param[%a];
            if(%element.paramType $= "intlist" || %element.paramType $= "string" || %element.paramType $= "int" || %element.paramType $= "float" || %element.paramType $= "bool")
                %element.setValue(%param);
            else if(%element.paramType $= "vector")
            {
                %element.getObject(0).setValue(getWord(%param,0));
                %element.getObject(1).setValue(getWord(%param,1));
                %element.getObject(2).setValue(getWord(%param,2));
            }
            else if(%element.paramType $= "list" || %element.paramType $= "datablock")
                %element.setSelected(%param);
            else if(%element.paramType $= "paintColor")
            {
                %element.picked = %param;
                %element.color = getColorI(getColorIDTable(%param));
            }
        }
    }
    for(%a=WrenchEvents_Box.highestOrder;%a>%targetID+1;%a--)
        WrenchEvents_Box.order[%a] = WrenchEvents_Box.order[%a-1];
    WrenchEvents_Box.order[%targetID+1] = %newSwatch;
    reorderEventsList();
    WrenchEvents_Box.setVisible(1);
    return %newSwatch;
}

function clientcmdregistereventsdone()
{
    $requestedServerEvents = true;
}

function callEvents()
{
    wrenchEventsDlg.newEvent();
    if($serverHasEventSystem)
        commandtoserver('requestNewEvents');
    else
        commandtoserver('requestWrenchEvents');
    schedule(2500,0,reordereventslist);
}

function clientcmdaddInputParam(%index,%param)
{
    $InputEventParam[%index] = %param;
}

    function clientcmdaddindenttoevent(%eventID,%indent)
{
    %swatch = -1;
    for(%a=0;%a<WrenchEvents_Box.highestOrder;%a++)
    {
        %sw = WrenchEvents_Box.order[%a];
        if(%sw.eventID == %eventID)
        {
            %swatch = %sw;
            break;
        }
    }
    if(!isObject(%swatch))
    {
        error("Couldn't find event swatch for addindenttoevent");
        return;
    }
    %swatch.indent = %indent;
    %swatch.position = %indent*$indentSize SPC getWord(%swatch.position,1);
}

function clientcmdaddcolortoevent(%eventID,%color)
{
    %swatch = -1;
    for(%a=0;%a<WrenchEvents_Box.highestOrder;%a++)
    {
        %sw = WrenchEvents_Box.order[%a];
        if(%sw.eventID == %eventID)
        {
            %swatch = %sw;
            break;
        }
    }
    if(!isObject(%swatch))
    {
        error("Couldn't find event swatch for addcolortoevent");
        return;
    }
    %swatch.colorID = %color;
    %swatch.color = $eventSwatchColor[%swatch.colorID];
}

function clientcmdsetinputparam(%eventID,%param)
{
    %swatch = -1;
    for(%a=0;%a<WrenchEvents_Box.highestOrder;%a++)
    {
        %sw = WrenchEvents_Box.order[%a];
        if(%sw.eventID == %eventID)
        {
            %swatch = %sw;
            break;
        }
    }
    if(!isObject(%swatch))
    {
        error("Couldn't find event swatch for setinputparam");
        return;
    }
    if(!isObjecT(%swatch.inputParam))
        error("Server says there should be an input parameter");
    else
    {
        if(%swatch.inputParam.paramType $= "string")
            %swatch.inputParam.setValue(%param);
        else if(%swatch.inputParam.paramType $= "datablock" || %swatch.inputParam.paramType $= "list")
            %swatch.inputParam.setSelected(%param);
    }
}

function clientcmdaddparamtoevent(%eventID,%paramID,%param)
{
    %swatch = -1;
    for(%a=0;%a<WrenchEvents_Box.highestOrder;%a++)
    {
        %sw = WrenchEvents_Box.order[%a];
        if(%sw.eventID == %eventID)
        {
            %swatch = %sw;
            break;
        }
    }
    if(!isObject(%swatch))
    {
        error("Couldn't find event swatch for addparamtoevent");
        return;
    }
    %element = %swatch.param[%paramID];
    if(%element.paramType $= "intlist" || %element.paramType $= "string" || %element.paramType $= "int" || %element.paramType $= "float" || %element.paramType $= "bool")
        %element.setValue(%param);
    else if(%element.paramType $= "vector")
    {
        %element.getObject(0).setValue(getWord(%param,0));
        %element.getObject(1).setValue(getWord(%param,1));
        %element.getObject(2).setValue(getWord(%param,2));
    }
    else if(%element.paramType $= "list" || %element.paramType $= "datablock")
        %element.setSelected(%param);
    else if(%element.paramType $= "paintColor")
    {
        %element.picked = %param;
        %element.color = getColorI(getColorIDTable(%param));
    }
}

function clientcmdaddnamedbricktoevent(%eventID,%name)
{
    %nameID = 0;
    for(%a=0;%a<ServerConnection.NTNameCount;%a++)
    {
        if(ServerConnection.NTName[%a] $= %name)
        {
            %nameID = %a;
            break;
        }
    }
	//echo("RECV: " @ %nameID);
    for(%a=0;%a<WrenchEvents_Box.highestOrder;%a++)
    {
        %sw = WrenchEvents_Box.order[%a];
        if(%sw.eventID == %eventID)
        {
            %sw.targetbutton.setActive(serverconnection.allownamedtargets);
            if(serverconnection.allownamedtargets)
                %sw.namedBrickButton.setSelected(%nameID);
            else
            {
                %sw.targetbutton.nofocus = true;
                %sw.targetbutton.setSelected(-1);
		%sw.targetbutton.setValue("Named Brick (" @ %name @ ")");
		%sw.targetButton.alienName = %name;
            }
            break;
        }
    }
}

package wrenchEventRewrite
{
	function GameConnection::onConnectionAccepted()
	{
		$serverHasEventSystem = false;
		$requestedServerEvents = false;
		Parent::onConnectionAccepted();
		schedule(5000,0,commandtoserver,'eventsystemversion',$eventSystem::Version);
	}

	function wrenchEventsDlg::clear(%this)
	{
		clearWrenchEventsBox();
		%this.newEvent();
	}

	function wrenchEventsDlg::createOutputParameters(%this,%swatch,%button,%className)
	{
		if(%button.getSelected() == -1)
			return;
		%objs = 0;
		for(%a=0;%a<%swatch.getCount();%a++)
		{
			if(%swatch.getObject(%a).isParam)
			{
				%obj[%objs] = %swatch.getObject(%a);
				%objs++;
			}
		}
		for(%a=0;%a<%objs;%a++)
			%obj[%a].delete();
		%swatch.params = 0;

		%list = $OutputEvent_parameterList[%className,%button.getSelected()];
		%offset = 420;//blaze it
		%respondSet = 0;
		for(%a=0;%a<getFieldCount(%list);%a++)
		{
			%param = getField(%list,%a);
			%type = getWord(%param,0);
			if(%type $= "int")
			{
				%ext = 36;
				if(mAbs(getWord(%param,2)) < 10)
					%ext = 18;
			 	%newParam = new GuiTextEditCtrl()
				{
					isParam = true;
                  			profile = "GuiTextEditProfile";
                  			horizSizing = "right";
                  			vertSizing = "bottom";
                  			position = %offset SPC "0";
                  			extent = %ext @ " 18";
                  			minExtent = "8 2";
                 		 	enabled = "1";
                 		 	visible = "1";
                  			clipToParent = "1";
                  			maxLength = "255";
                  			historySize = "0";
                  			password = "0";
                  			tabComplete = "0";
                  			sinkAllKeyEvents = "0";
					paramType = "int";
               			};
                  		%newParam.command = "wrenchEventsDlg.VerifyInt(" @ %newParam @ "," @ getWord(%param,1) @ "," @ getWord(%param,2) @ ");";
				%swatch.param[%swatch.params] = %newParam;
				%swatch.params++;
				%swatch.add(%newParam);
				%newParam.setValue(getWord(%param,3));
				%offset += %ext+2;
				if(!%respondset)
				{
					%newParam.makefirstresponder(true);
					%respondset = true;
				}
			}
			else if(%type $= "paintcolor")
			{
				%newParam = new GuiSwatchCtrl()
				{
					isParam = true;
					paramType = "paintcolor";
            				profile = "GuiDefaultProfile";
            				horizSizing = "right";
            				vertSizing = "bottom";
                  			position = %offset SPC "0";
            				extent = "16 16";
            				minExtent = "8 2";
            				enabled = "1";
            				visible = "1";
           				clipToParent = "1";
            				color = "255 255 255 255";

            				new GuiBitmapButtonCtrl()
					{
               					profile = "GuiDefaultProfile";
               					horizSizing = "right";
               					vertSizing = "bottom";
               					position = "0 0";
               					extent = "16 16";
               					minExtent = "8 2";
               					enabled = "1";
               					visible = "1";
               					clipToParent = "1";
               					text = " ";
               					groupNum = "-1";
               					buttonType = "PushButton";
               					lockAspectRatio = "0";
               					alignLeft = "0";
               					alignTop = "0";
               					overflowImage = "0";
               					mKeepCached = "0";
               					mColor = "255 255 255 255";
            				};
         			};
				%newparam.picked = 0;
				%newParam.color = getColorI(getColorIDTable(0));
				%swatch.add(%newParam);
				%pos = vectorAdd(vectorAdd(WrenchEvents_Window.position,WrenchEvents_Scroll.position),%newParam.position);
				%pos = "vectorAdd(vectorAdd(\"" @ getWord(%pos,0) SPC getWord(%pos,1) @ "\"," @ %swatch @ ".position),WrenchEvents_Box.position)";
				%newParam.getObject(0).command = "colorPicker(" @ %newParam @ "," @ WrenchEvents_Window @ "," @ !$eventShowTrans @ "," @ %pos @ ");";
				%offset += 18;
				%swatch.param[%swatch.params] = %newParam;
				%swatch.params++;
			}
			else if(%type $= "dataBlock")
			{
               			%newParam = new GuiPopUpMenuCtrl()
				{
					isParam = true;
                  			profile = "GuiPopUpMenuProfile";
                  			horizSizing = "right";
                  			vertSizing = "bottom";
                  			position = %offset SPC "0";
                  			extent = "100 18";
                  			minExtent = "8 2";
                  			enabled = "1";
                  			visible = "1";
                  			clipToParent = "1";
                  			maxLength = "255";
                 		 	maxPopupHeight = "200";
					paramType = "datablock";
               			};
				%offset += 102;
				%swatch.add(%newParam);
				%swatch.param[%swatch.params] = %newParam;
				%swatch.params++;
				populateButton(%newParam,getword(%param,1));
			}
			else if(%type $= "list")
			{
				%newParam = new GuiPopUpMenuCtrl()
				{
					isParam = true;
                  			profile = "GuiPopUpMenuProfile";
                  			horizSizing = "right";
                  			vertSizing = "bottom";
                  			position = %offset SPC "0";
                  			extent = "100 18";
                  			minExtent = "8 2";
                  			enabled = "1";
                  			visible = "1";
                  			clipToParent = "1";
                  			maxLength = "255";
                 		 	maxPopupHeight = "200";
					paramType = "list";
               			};
				%offset += 102;
				%swatch.add(%newParam);
				%swatch.param[%swatch.params] = %newParam;
				%swatch.params++;
				%iter = 1;
				while(%iter < getWordCount(%param))
				{
					%newParam.add(getWord(%param,%iter),getWord(%param,%iter+1));
					%newParam.entryID[getWord(%param,%iter)] = getWord(%param,%iter+1);
					%iter+=2;
				}
			}
			else if(%type $= "string" || %type $= "intlist")
			{
				%ext = getWord(%param,2);
				if(%type $= "intlist")
					%ext = getWord(%param,1);
			        %newParam = new GuiTextEditCtrl()
				{
					isParam = true;
                     			profile = "GuiTextEditProfile";
                     			horizSizing = "right";
                     			vertSizing = "bottom";
                  			position = %offset SPC "0";
                     			extent = %ext SPC "18";
                    		 	minExtent = "8 2";
                     			enabled = "1";
                     			visible = "1";
                     			clipToParent = "1";
                     			maxLength = "255";
                     			historySize = "0";
                     			password = "0";
                     			tabComplete = "0";
                     			sinkAllKeyEvents = "0";
					paramType = "string";
                  		};
				if(%type $= "intlist")
					%newParam.paramType = "intlist";
				%swatch.add(%newParam);
				%swatch.param[%swatch.params] = %newParam;
				%swatch.params++;
				%offset += %ext+2;
				if(!%respondset)
				{
					%newParam.makefirstresponder(true);
					%respondset = true;
				}
			}
			else if(%type $= "vector")
			{
				%max = getWord(%param,1);
               			%newParam = new GuiSwatchCtrl()
				{
                  			profile = "GuiDefaultProfile";
                  			horizSizing = "right";
                  			vertSizing = "bottom";
                  			position = %offset SPC "0";
                  			extent = "101 18";
                  			minExtent = "8 2";
                  			enabled = "1";
                  			visible = "1";
                  			clipToParent = "1";
                  			color = "0 0 0 191";
					isParam = true;
					paramType = "vector";

                  			new GuiTextEditCtrl()
					{
                     				profile = "GuiTextEditProfile";
                     				horizSizing = "right";
                     				vertSizing = "bottom";
                     				position = "2 0";
                     				extent = "31 18";
                     				minExtent = "8 2";
                    				enabled = "1";
                     				visible = "1";
                     				clipToParent = "1";
                     				maxLength = "255";
                     				historySize = "0";
                     				password = "0";
                     				tabComplete = "0";
                     				sinkAllKeyEvents = "0";
						maxNum = %max;
                  			};
                  			new GuiTextEditCtrl()
					{
                     				profile = "GuiTextEditProfile";
                     				horizSizing = "right";
                     				vertSizing = "bottom";
                     				position = "35 0";
                     				extent = "31 18";
                     				minExtent = "8 2";
                     				enabled = "1";
                     				visible = "1";
                     				clipToParent = "1";
                     				maxLength = "255";
                     				historySize = "0";
                     				password = "0";
                     				tabComplete = "0";
                     				sinkAllKeyEvents = "0";
						maxNum = %max;
                  			};
                  			new GuiTextEditCtrl()
					{
                     				profile = "GuiTextEditProfile";
                     				horizSizing = "right";
                     				vertSizing = "bottom";
                    				position = "68 0";
                     				extent = "31 18";
                     				minExtent = "8 2";
                     				enabled = "1";
                     				visible = "1";
                     				clipToParent = "1";
                    				maxLength = "255";
                     				historySize = "0";
                     				password = "0";
                     				tabComplete = "0";
                     				sinkAllKeyEvents = "0";
						maxNum = %max;
                  			};
               			};
				%offset += 103;
				%swatch.add(%newParam);
				%swatch.param[%swatch.params] = %newParam;
				%swatch.params++;
				if(!%respondset)
				{
					%newParam.getObject(0).makefirstresponder(true);
					%respondset = true;
				}
			}
			else if(%type $= "bool")
			{
               			%newParam = new GuiCheckBoxCtrl()
				{
                  			profile = "GuiCheckBoxProfile";
                  			horizSizing = "right";
                  			vertSizing = "bottom";
                  			position = %offset SPC "0";
                  			extent = "18 18";
                  			minExtent = "8 2";
                  			enabled = "1";
                  			visible = "1";
                  			clipToParent = "1";
                  			groupNum = "-1";
                  			buttonType = "ToggleButton";
					isParam = true;
					text="";
					paramType = "bool";
              			};
				%swatch.add(%newParam);
				%swatch.param[%swatch.params] = %newParam;
				%swatch.params++;
				%offset += 20;
			}
			else if(%type $= "float")
			{
				%newParam = new GuiSliderCtrl()
				{
                  			profile = "GuiSliderProfile";
                  			horizSizing = "right";
                  			vertSizing = "bottom";
                  			position = %offset SPC "0";
                  			extent = "100 36";
                  			minExtent = "8 2";
                  			enabled = "1";
                  			visible = "1";
                  			clipToParent = "1";
                  			command = " $thisControl.setValue(mFloor( $thisControl.getValue() * (1 / " @ getWord(%param,3) @ ") )   * " @ getword(%param,3) @") ;";
                  			range = getword(%param,1) SPC getWord(%param,2);
                  			ticks = "10";
                  			value = "1";
                  			snap = "0";
					isParam = true;
					paramType = "float";
               			};
				%swatch.add(%newParam);
				%swatch.param[%swatch.params] = %newParam;
				%swatch.params++;
				%offset += 102;
				%newParam.setValue(getword(%param,4));
			}
		}
	}

	function wrenchEventsDlg::createOutputList(%this,%swatch,%button,%event)
	{
		if(%button.getSelected() == -1)
			return;
		%objs = 0;
		for(%a=0;%a<%swatch.getCount();%a++)
		{
			if(%swatch.getObject(%a).isParam)
			{
				%obj[%objs] = %swatch.getObject(%a);
				%objs++;
			}
		}
		for(%a=0;%a<%objs;%a++)
			%obj[%a].delete();

		for(%a=0;%a<%swatch.getcount();%a++)
			if(%swatch.getObject(%a).isOutputbutton)
				%swatch.getObject(%a).delete();

		%swatch.params = 0;

		%tar = %button.getSelected();
		if(%tar == 999)
		{
			%tar = %button.brickOption;
			if(!isObject(%swatch.namedBrickButton))
			{
				%namedBrickButton = new GuiPopUpMenuCtrl()
				{
                  			profile = "GuiPopUpMenuProfile";
                  			horizSizing = "right";
                  			vertSizing = "bottom";
                  			position = "216 18";
                  			extent = "100 18";
                  			minExtent = "8 2";
                  			enabled = "1";
                  			visible = "1";
                  			clipToParent = "1";
                  			maxLength = "255";
                  			maxPopupHeight = "200";
		  			isNameButton = true;
				};
				addBrickNamesToButton(%namedBrickButton);
				%swatch.add(%namedBrickButton);
				%swatch.namedBrickButton = %namedBrickButton;
			}
		}
		else if(isObject(%swatch.namedBrickButton))
			%swatch.namedBrickButton.delete();

		%targets = $InputEvent_TargetListfxDTSBrick_[%event];
		%className = getWord(getField(%targets,%tar),1);

		 %outputButton = new GuiPopUpMenuCtrl() {
                  profile = "GuiPopUpMenuProfile";
                  horizSizing = "right";
                  vertSizing = "bottom";
                  position = "318 0";
                  extent = "100 18";
                  minExtent = "8 2";
                  enabled = "1";
                  visible = "1";
                  clipToParent = "1";
                  command = "wrenchEventsDlg.createOutputParameters(88409,88418,fxDTSBrick);";
                  maxLength = "255";
                  maxPopupHeight = "200";
		  isOutputButton = true;
               };
		%swatch.add(%outputButton);
		%swatch.outputButton = %outputButton;
		%outputButton.command = "wrenchEventsDlg.createOutputParameters(" @ %swatch @ "," @ %outputButton @ "," @ %className @ ");";
		addOutputEventsToButton(%outputButton,%className);
		%outputButton.setSelected(-1);
		if(!%button.noFocus)
			%outputButton.ddsOpenMenu();
		else
			%button.noFocus = false;

	}

	function wrenchEventsDlg::createTargetList(%this,%swatch,%button)
	{
		%event = %button.getSelected();
		if(%event != -1)
		{
		%objs = 0;
		for(%a=0;%a<%swatch.getCount();%a++)
		{
			if(%swatch.getObject(%a).isParam)
			{
				%obj[%objs] = %swatch.getObject(%a);
				%objs++;
			}
		}
		for(%a=0;%a<%objs;%a++)
			%obj[%a].delete();

		for(%a=0;%a<%swatch.getcount();%a++)
			if(%swatch.getObject(%a).isOutputbutton)
				%swatch.getObject(%a).delete();

		for(%a=0;%a<%swatch.getcount();%a++)
			if(%swatch.getObject(%a).isTargetButton)
				%swatch.getObject(%a).delete();
		%swatch.params = 0;
		if(isObject(%swatch.inputParam))
			%swatch.inputParam.delete();

			if(getField($InputEventParam[%event],0) $= "string")
			{
				%newParam = new GuiTextEditCtrl()
				{
					isInputParam = true;
                     			profile = "GuiTextEditProfile";
                     			horizSizing = "right";
                     			vertSizing = "bottom";
                  			position = "114 18";
                     			extent = "100 18";
                    		 	minExtent = "8 2";
                     			enabled = "1";
                     			visible = "1";
                     			clipToParent = "1";
                     			maxLength = "255";
                     			historySize = "0";
                     			password = "0";
                     			tabComplete = "0";
                     			sinkAllKeyEvents = "0";
					paramType = "string";
                  		};
				%swatch.add(%newParam);
				%swatch.inputParam = %newParam;
			}
			else if(getField($InputEventParam[%event],0) $= "datablock")
			{
		               	%inputParam = new GuiPopUpMenuCtrl()
				{
                 			profile = "GuiPopUpMenuProfile";
                  			horizSizing = "right";
                  			vertSizing = "bottom";
                  			position = "114 18";
                     			extent = "100 18";
                  			minExtent = "8 2";
                  			enabled = "1";
                  			visible = "1";
                  			clipToParent = "1";
                  			maxLength = "255";
                  			maxPopupHeight = "200";
					paramType = "datablock";
					isInputParam = true;
               			};
				%swatch.add(%inputParam);
				%swatch.inputParam = %inputParam;
				populateButton(%inputParam,getField($inputEventParam[%event],1));
			}
			else if(getField($InputEventParam[%event],0) $= "list")
			{
				%param = getField($InputEventParam[%event],1);
		               	%inputParam = new GuiPopUpMenuCtrl()
				{
                 			profile = "GuiPopUpMenuProfile";
                  			horizSizing = "right";
                  			vertSizing = "bottom";
                  			position = "114 18";
                     			extent = "100 18";
                  			minExtent = "8 2";
                  			enabled = "1";
                  			visible = "1";
                  			clipToParent = "1";
                  			maxLength = "255";
                  			maxPopupHeight = "200";
					paramType = "list";
					isInputParam = true;
               			};
				%swatch.add(%inputParam);
				%swatch.inputParam = %inputParam;
				%iter = 0;
				while(%iter < getWordCount(%param))
				{
					%inputParam.add(getWord(%param,%iter),getWord(%param,%iter+1));
					%inputParam.entryID[getWord(%param,%iter)] = getWord(%param,%iter+1);
					%iter+=2;
				}
			}

               		%theTargetButton = new GuiPopUpMenuCtrl()
			{
                 		profile = "GuiPopUpMenuProfile";
                  		horizSizing = "right";
                  		vertSizing = "bottom";
                  		position = "216 0";
                  		extent = "100 18";
                  		minExtent = "8 2";
                  		enabled = "1";
                  		visible = "1";
                  		clipToParent = "1";
                  		maxLength = "255";
                  		maxPopupHeight = "200";
                     		lastClass = "fxDTSBrick";
				isTargetButton = true;
               		};
                	%theTargetButton.command = "wrenchEventsDlg.createOutputList(" @ %swatch @ "," @ %theTargetbutton @ "," @ %event @ ");";
			addTargetsToButton(%theTargetButton,%event);
			%swatch.add(%theTargetButton);
			%swatch.targetButton = %theTargetButton;
			%theTargetButton.setSelected(-1);

			if(!hasNewEvent())
				%this.newEvent();

			if(!%button.noFocus)
				%theTargetButton.ddsOpenMenu();
			else
				%button.noFocus = false;
		}
		else
		{
			if(isObject(%swatch.targetButton) || isObject(%swatch.outputButton))
			{
				%swatch.delete();
				reorderEventsList();
			}
		}
	}

	function wrenchEventsDlg::newEvent(%this)
	{
	       $newestEventLine = new GuiSwatchCtrl() {
               profile = "GuiDefaultProfile";
               horizSizing = "width";
               vertSizing = "bottom";
               position = "0 " @ 42*WrenchEvents_Box.highestOrder;
               extent = getword(wrenchEvents_Scroll.extent,0) @ " 36";
               minExtent = "8 2";
               enabled = "1";
               visible = "1";
               clipToParent = "1";
               color = "0 0 0 51";
            };
		$newestEventLine.indent = 0;
		$newestEventLine.colorID = 0;
		if(WrenchEvents_Box.highestOrder < 1)
			WrenchEvents_Box.highestOrder = 0;
		$newestEventLine.order = WrenchEvents_Box.highestOrder;
		WrenchEvents_Box.order[WrenchEvents_Box.highestOrder] = $newestEventLine;
		WrenchEvents_Box.highestOrder++;


					%backBut = new GuiBitmapButtonCtrl()
					{
               					profile = "GuiDefaultProfile";
               					horizSizing = "right";
               					vertSizing = "bottom";
               					position = "0 0";
               					extent = getword(wrenchEvents_Scroll.extent,0) @ " 36";
               					minExtent = "8 2";
               					enabled = "1";
               					visible = "1";
               					clipToParent = "1";
               					text = " ";
               					groupNum = "-1";
               					buttonType = "PushButton";
               					lockAspectRatio = "0";
               					alignLeft = "0";
               					alignTop = "0";
               					overflowImage = "0";
               					mKeepCached = "0";
               					mColor = "100 100 100 0";
            				};
		$newestEventLine.add(%backBut);
		$newestEventLine.backBut = %backBut;
		%backBut.command = "backButtonClicked(" @ $newestEventLine @ ");";

               %theMinmize = new GuiBitmapButtonCtrl() {
                  profile = "GuiDefaultProfile";
                  horizSizing = "right";
                  vertSizing = "bottom";
                  position = "0 0";
                  extent = "12 12";
                  minExtent = "8 2";
                  enabled = "1";
                  visible = "1";
                  clipToParent = "1";
                  groupNum = "-1";
                  buttonType = "PushButton";
                  bitmap = "add-ons/system_eventing/ui/ButtonMin";
                  lockAspectRatio = "0";
                  alignLeft = "0";
                  alignTop = "0";
                  overflowImage = "0";
                  mKeepCached = "0";
                  mColor = "255 255 255 255";
			text="";
               };

		$newestEventLine.add(%theMinmize);
		$newestEventLine.theMinmize = %theMinmize;
		%theMinmize.command = "eventCollapse(" @ $newesteventline @ ");";



               %theIndent = new GuiBitmapButtonCtrl() {
                  profile = "GuiDefaultProfile";
                  horizSizing = "right";
                  vertSizing = "bottom";
                  position = "23 18";
                  extent = "12 12";
                  minExtent = "8 2";
                  enabled = "1";
                  visible = "1";
                  clipToParent = "1";
                  groupNum = "-1";
                  buttonType = "PushButton";
                  bitmap = "add-ons/system_eventing/ui/ButtonRArw";
                  lockAspectRatio = "0";
                  alignLeft = "0";
                  alignTop = "0";
                  overflowImage = "0";
                  mKeepCached = "0";
                  mColor = "255 255 255 255";
		text="";
               };

		$newestEventLine.add(%theIndent);
		$newestEventLine.theIndent = %theIndent;
		%theIndent.command = "eventIndent(" @ $newesteventline @ ");";

               %theDedent = new GuiBitmapButtonCtrl() {
                  profile = "GuiDefaultProfile";
                  horizSizing = "right";
                  vertSizing = "bottom";
                  position = "0 18";
                  extent = "12 12";
                  minExtent = "8 2";
                  enabled = "1";
                  visible = "1";
                  clipToParent = "1";
                  groupNum = "-1";
                  buttonType = "PushButton";
                  bitmap = "add-ons/system_eventing/ui/ButtonLArw";
                  lockAspectRatio = "0";
                  alignLeft = "0";
                  alignTop = "0";
                  overflowImage = "0";
                  mKeepCached = "0";
                  mColor = "255 255 255 255";
		text="";
               };

		$newestEventLine.add(%theDedent);
		$newestEventLine.theDedent = %theDedent;
		%theDedent.command = "eventDedent(" @ $newesteventline @ ");";

               %theUpper = new GuiBitmapButtonCtrl() {
                  profile = "GuiDefaultProfile";
                  horizSizing = "right";
                  vertSizing = "bottom";
                  position = "11 12";
                  extent = "12 12";
                  minExtent = "8 2";
                  enabled = "1";
                  visible = "1";
                  clipToParent = "1";
                  groupNum = "-1";
                  buttonType = "PushButton";
                  bitmap = "add-ons/system_eventing/ui/ButtonUArw";
                  lockAspectRatio = "0";
                  alignLeft = "0";
                  alignTop = "0";
                  overflowImage = "0";
                  mKeepCached = "0";
                  mColor = "255 255 255 255";
		text="";
               };

		$newestEventLine.add(%theUpper);
		$newestEventLine.theUpper = %theUpper;
		%theUpper.command = "eventUpper(" @ $newesteventline @ ");";

               %theDowner = new GuiBitmapButtonCtrl() {
                  profile = "GuiDefaultProfile";
                  horizSizing = "right";
                  vertSizing = "bottom";
                  position = "11 24";
                  extent = "12 12";
                  minExtent = "8 2";
                  enabled = "1";
                  visible = "1";
                  clipToParent = "1";
                  groupNum = "-1";
                  buttonType = "PushButton";
                  bitmap = "add-ons/system_eventing/ui/ButtonDArw";
                  lockAspectRatio = "0";
                  alignLeft = "0";
                  alignTop = "0";
                  overflowImage = "0";
                  mKeepCached = "0";
                  mColor = "255 255 255 255";
		text="";
               };

		$newestEventLine.add(%theDowner);
		$newestEventLine.theDowner = %theDowner;
		%theDowner.command = "eventDowner(" @ $newesteventline @ ");";


               %theCheck = new GuiCheckBoxCtrl() {
                  profile = "GuiCheckBoxProfile";
                  horizSizing = "right";
                  vertSizing = "bottom";
                  position = "38 0";
                  extent = "28 18";
                  minExtent = "8 2";
                  enabled = "1";
                  visible = "1";
                  clipToParent = "1";
                  text = WrenchEvents_Box.highestOrder-1;
                  groupNum = "-1";
                  buttonType = "ToggleButton";
               };
		$newestEventLine.add(%theCheck);
		%theCheck.setValue(1);

               %theDelay = new GuiTextEditCtrl() {
                  profile = "GuiTextEditProfile";
                  horizSizing = "right";
                  vertSizing = "bottom";
                  position = "76 0";
                  extent = "36 18";
                  minExtent = "8 2";
                  enabled = "1";
                  visible = "1";
                  clipToParent = "1";
                  command = "$ThisControl.setText(mClamp($ThisControl.getValue(), 0, 300000));";
                  maxLength = "255";
                  historySize = "0";
                  password = "0";
                  tabComplete = "0";
                  sinkAllKeyEvents = "0";
               };
		$newestEventLine.add(%theDelay);
               %thisInputEvent = new GuiPopUpMenuCtrl() {
                  profile = "GuiPopUpMenuProfile";
                  horizSizing = "right";
                  vertSizing = "bottom";
                  position = "114 0";
                  extent = "100 18";
                  minExtent = "8 2";
                  enabled = "1";
                  visible = "1";
                  clipToParent = "1";
                  maxLength = "255";
                  maxPopupHeight = "200";
               };
		$newestEventLine.add(%thisInputEvent);
		$newestEventLine.inputButton = %thisInputEvent;
		$newestEventLine.delayBox = %theDelay;
		$newestEventLine.enabledBox = %theCheck;
		$newestEventLine.params = 0;
		%thisInputEvent.command = "wrenchEventsDlg.createTargetList(" @ $newestEventLine @ "," @ %thisInputEvent @ ");";
		addInputEventsToButton(%thisInputEvent);
		%thisInputEvent.setSelected(-1);

		WrenchEvents_Box.add($newestEventLine);
		WrenchEvents_Box.extent = getword(wrenchEvents_Scroll.extent,0) SPC 42*WrenchEvents_Box.highestOrder;
	}

	function wrenchEventsDlg::onWake(%this)
	{
		$eventSelectingmode = 0;
		%wait = 0;
		if(!$requestedServerEvents)
		{
			%wait = 1;
			commandtoserver('eventsystemversion',$eventsystem::version);
			commandtoserver('RequestEventTables');
			deleteVariables("$InputEventParam*");
			commandtoserver('requestInputParams');
		}
		changeEventWindow();
		if(WrenchLock_Events.getValue())
			return;
		clearWrenchEventsBox();
		if(%wait)
			schedule(2500,0,callEvents);
		else
			callEvents();
		newEventDropDown.setSelected(-1);
	}

	function wrenchEventsDlg::send(%this)
	{
		commandtoserver('clearEvents');
		for(%a=0;%a<WrenchEvents_Box.highestOrder;%a++)
		{
			%swatch = WrenchEvents_Box.order[%a];
			if(!isObject(%swatch.targetButton))
				continue;
			if(!isObject(%swatch.outputButton))
				continue;
			%enabled = %swatch.enabledBox.getValue();
			%delay = %swatch.delayBox.getValue();
			%input = %swatch.inputButton.getSelected();
			if(%input == -1)
				continue;
			%target = %swatch.targetButton.getSelected();
			%output = %swatch.outputButton.getSelected();
			if(isObject(%swatch.inputParam))
				commandtoserver('setInputParam',%a,getParam(%swatch.inputParam));
			commandtoserver('AddEventIndent',%a,%swatch.indent);
			commandtoserver('AddEventColor',%a,%swatch.colorid);
			if(%output == -1)
				continue;
			if(%swatch.params == 0)
			{
				if(%target == 999 || %target == -1)
				{
					if(isObject(%swatch.namedBrickButton))
					{
						commandtoserver('AddEvent',%enabled,%input,%delay,-1,%swatch.namedBrickButton.getSelected(),%output);
						//echo("SEND" SPC %swatch.namedBrickButton.getSelected());
					}
					else
						commandtoserver('AddEvent',%enabled,%input,%delay,-1,%swatch.targetbutton.alienname,%output);
				}
				else
					commandtoserver('AddEvent',%enabled,%input,%delay,%target,-1,%output);
			}
			else
			{
				%arg1 = getParam(%swatch.param[0]);
				if(%swatch.params == 1)
				{
					if(%target == 999 || %target == -1)
					{
						if(isObject(%swatch.namedBrickButton))
						{
							commandtoserver('AddEvent',%enabled,%input,%delay,-1,%swatch.namedBrickButton.getSelected(),%output,%arg1);
							//echo("SEND" SPC %swatch.namedBrickButton.getSelected());
						}
						else
							commandtoserver('AddEvent',%enabled,%input,%delay,-1,%swatch.targetbutton.alienname,%output,%arg1);
					}
					else
						commandtoserver('AddEvent',%enabled,%input,%delay,%target,-1,%output,%arg1);
				}
				else
				{
					%arg2 = getParam(%swatch.param[1]);
					if(%swatch.params == 2)
					{
						if(%target == 999 || %target == -1)
						{
							if(isObject(%swatch.namedBrickButton))
								commandtoserver('AddEvent',%enabled,%input,%delay,-1,%swatch.namedBrickButton.getSelected(),%output,%arg1,%arg2);
							else
								commandtoserver('AddEvent',%enabled,%input,%delay,-1,%swatch.targetbutton.alienname,%output,%arg1,%arg2);
						}
						else
							commandtoserver('AddEvent',%enabled,%input,%delay,%target,-1,%output,%arg1,%arg2);
					}
					else
					{
						%arg3 = getParam(%swatch.param[2]);
						if(%swatch.params == 3)
						{
							if(%target == 999 || %target == -1)
							{
								if(isObject(%swatch.namedBrickButton))
									commandtoserver('AddEvent',%enabled,%input,%delay,-1,%swatch.namedBrickButton.getSelected(),%output,%arg1,%arg2,%arg3);
								else
									commandtoserver('AddEvent',%enabled,%input,%delay,-1,%swatch.targetbutton.alienname,%output,%arg1,%arg2,%arg3);
							}
							else
								commandtoserver('AddEvent',%enabled,%input,%delay,%target,-1,%output,%arg1,%arg2,%arg3);
						}
						else
						{
							%arg4 = getParam(%swatch.param[3]);
							//echo("Arg 4: " @ %arg4);
							if(%target == 999 || %target == -1)
							{
								if(isObject(%swatch.namedBrickButton))
									commandtoserver('AddEvent',%enabled,%input,%delay,-1,%swatch.namedBrickButton.getSelected(),%output,%arg1,%arg2,%arg3,%arg4);
								else
									commandtoserver('AddEvent',%enabled,%input,%delay,-1,%swatch.targetbutton.alienname,%output,%arg1,%arg2,%arg3,%arg4);
							}
							else
								commandtoserver('AddEvent',%enabled,%input,%delay,%target,-1,%output,%arg1,%arg2,%arg3,%arg4);
						}
					}
				}
			}
		}
		canvas.popDialog(wrenchEventsDlg);
		canvas.popDialog(wrenchDlg);
	}

	function clientcmdaddevent(%a,%b,%c,%d,%e,%f,%g,%h,%i)
	{
		%swatch = WrenchEvents_Box.order[WrenchEvents_Box.highestOrder-1];

		if($serverHasEventSystem)
		{
			%swatch.enabledBox.setValue(%a);
			%swatch.delayBox.setValue(%b);
			%swatch.inputButton.noFocus = true;
			%swatch.inputButton.setSelected(%c);
			%swatch.targetButton.noFocus = true;
			if(%d == -1)
			{
				if(ServerConnection.NTNameCount > 0 && serverconnection.allownamedtargets)
					%swatch.targetbutton.setselected(999);
				else
				{
					//%swatch.targetbutton.add("Named Brick",999);
					%swatch.targetbutton.setActive(false);
					%swatch.targetbutton.setSelected(999);
					%swatch.targetbutton.setValue("Named Brick");
				}
			}
			else
				%swatch.targetButton.setSelected(%d);
			%swatch.outputButton.setSelected(%e);
			%swatch.eventID = %f;
			return;
		}

		%event = %a;

		%enabled = getField(%event,0);
		%input = getField(%event,1);
		%delay = getField(%event,2);
		%target = getField(%event,3);
		%name = getField(%event,4);
		%output = getField(%event,5);
		%numParams = getFieldCount(%event)-6;
		%swatch.enabledBox.setValue(%enabled);
		%swatch.delayBox.setValue(%delay);
		%swatch.inputButton.noFocus = true;
		%swatch.inputButton.setSelected(%input);
		if(%target == -1)
			%target = 999;
		%swatch.targetButton.noFocus = true;
		%swatch.targetButton.setSelected(%target);
		if(%target == 999)
		{
			if(ServerConnection.NTNameCount > 0 && serverconnection.allownamedtargets)
				%swatch.namedBrickButton.setSelected(%name);
			else
			{
				%swatch.targetbutton.setActive(false);
				%swatch.targetbutton.setSelected(-1);
				%swatch.targetbutton.alienname = %name;
				%swatch.targetbutton.setValue("Named Brick (" @ %name @ ")");
			}
		}
		%swatch.outputButton.setSelected(%output);
		for(%a=0;%a<%numParams;%a++)
		{
			%param = getField(%event,6+%a);
			if(strlen(%param) > 0)
			{
				%element = %swatch.param[%a];
				if(%element.paramType $= "intlist" || %element.paramType $= "string" || %element.paramType $= "int" || %element.paramType $= "float" || %element.paramType $= "bool")
					%element.setValue(%param);
				else if(%element.paramType $= "vector")
				{
					%element.getObject(0).setValue(getWord(%param,0));
					%element.getObject(1).setValue(getWord(%param,1));
					%element.getObject(2).setValue(getWord(%param,2));
				}
				else if(%element.paramType $= "list" || %element.paramType $= "datablock")
					%element.setSelected(%param);
				else if(%element.paramType $= "paintColor")
				{
					%element.picked = %param;
					%element.color = getColorI(getColorIDTable(%param));
				}
			}
		}
	}
};
activatepackage(wrenchEventRewrite);

function reloadEventingClient()
{
	exec("add-ons/system_eventing/client.cs");
}
